#ifndef INCLUDED_POINT_H
#define INCLUDED_POINT_H

#pragma warning(disable : 4786)

#include <functional>

#include <iostream>

using namespace std;

class Point
{
	public:

		Point(void);

		Point(const double & x, const double & y);

		void toStream(std::ostream & output_stream) const;
		void fromStream(std::istream & input_stream);

		double x;
		double y;
};

std::ostream & operator<<(std::ostream & output_stream, const Point & point);
std::istream & operator>>(std::istream & input_stream, Point & point);

class PointSmallerXCompare : public binary_function<const Point &, const Point &, bool>
{
	public:

		bool operator()(const Point & first, const Point & second) const;
};

class PointLargerXCompare : public binary_function<const Point &, const Point &, bool>
{
	public:

		bool operator()(const Point & first, const Point & second) const;
};

#endif